.TH atscap 1 "2007-Dec-07" "atscap-1.1"  "(C) 2004-2007 inkling@users.sourceforge.net"
.SH NAME
.B atscap
\- ATSC Transport Stream Capture Application Program
.SH SYNOPSIS
.B atscap [\-123ACEDNRSTWadehklmnqtvx]
.IP
.B [\-F frequencies]
.br
.B [\-c cfgpath]
.br
.B [\-p outpath]
.br
.B [\-o capfile]
.br
.B [\-z QoS]
.br
.B [\-i devnum]
.br
.B [\-r file.ts]
.br
.B [\-s seconds]
.br
.B [\-u addr:port]
.br
.B [\-w addr:mask:port:threads]

.SH DESCRIPTION
This manual page describes the options for
.B atscap,
a capture application for digital TV using the North American ATSC
specification with the Linux DVB-API for supported ATSC capture devices.

.SH OPTIONS WITHOUT PARAMETERS
.TP
These options enable features to do various things.

.TP
.B \-d
Forks to a process detached from stdio.
.IP
Control is returned immediately to caller.
Use with -s if you don't want script to wait.
Use without -s and it enters timer daemon mode.

.TP
.B \-e
Extra error detail toggle off.
.IP
Disables filling .html capture log with errors/second detail.

.TP
.B \-h
Help, possibly shows more options than this generic page.

.TP
.B \-k
No keyboard.
.IP
Disables stdin. Useful for unattended operation.
.br
See also:
.B -q

.TP
.B \-l
Log debug, shows a whole lot more than anyone wants to know.
.IP
Default is to log startup and brief capture info. This option may
drop packets unless using tmpfs for logging.

.TP
.B \-m
Captures sequence and frame data to .tsx files.
.IP
MPEG sequence dump makes xtscut usable immediately after capture, without
having to generate .tsx file with atscut -s. Data is generated only for
single program captures.

.TP
.B \-n
Pad single program cap with NULL packets.
.IP
NULL packets replace removed packets to keep bitrate constant for hardware
players that need it for TCP or UDP playback. It uses 8.7G per hour. Use
.B atscut -e pgmnum
to extract NULLs.

.TP
.B \-q
Quiet disables stdout, but doesn't detach.
.IP
Control is not returned to caller until completion. Use with -s if you
want cron script to wait.

.TP
.B \-v
Show version, boilerplate and memory buffer use.

.TP
.B \-A
Strict enforcement ATSC A/65b & MPEG TS tables reserved bits:
.IP
If VCT or MGT or EPG stop working with this it means the station is a bit
out of spec. Default checks are CRC32, Table ID and protocol version,
for tables that have them. MPEG Video and A52 audio are not checked.

.TP
.B \-S
Setup the configuration by scanning all the channels.
.IP
This takes a while to run. You should only have to run it when upgrading.
It will overwrite the .conf files with any detected channels, but also wipes
out any event timers you might have placed in those files. It sometimes
gets the callsign wrong, but you can edit the atscap[0-3].tsid.[vsb/qam]
file to retain the callsigns you want to keep the next time you use -S.


.SH GNU SCREEN OPTIONS
.TP
These options require GNU screen. Version 4.00.02 is known to work.

.TP
.B \-W
Use GNU screen to manage the session. Default: no.
.TP
.B \-D
Use GNU screen to start detached. Default: no.
.TP
.B \-R
Use GNU screen to re-attach session. Default: no.

.SH EXPERIMENTAL OPTIONS
.TP
These options may or may not work correctly.

.TP
.B \-N
No boilerplate/mem usage splash delay.
.IP
Makes it start immediately. This is
.B NOT
recommended because the devices usually need a few seconds, to reset 
and load the microcode, before attempting to issue any commands.

.TP
.B WARNING: SPIN-DOWN MAY NOT WORK OR MAY CAUSE FILESYSTEM PROBLEMS!
.IP
.B There is a risk of file-system corruption because of spin-down,
.B mostly due to the risk of the drive not spinning up ever again.
.B Consider using a dedicated physical volume for captures.
.PP
There may be a significant power savings if you can spin-down your drives.
Not all hard drives support spin-down. Most new ones do, however spin-down
does not work with smartd because smartd wakes the drive up to query it.
Non-dedicated systems may prefer to have smartd over spin-down.
Also,
.B hdparm -S
may be IDE and SATA specific. You may not be able to spin-down
SCSI or USB or 1394 (FireWire) attached drives with this method. For IDE, you
can use
.B hdparm -C
to inspect it and try
.B hdparm -S60
to spin-down after 5m idle.
.TP
.B \-E
Energy Saver operation.
.IP
Use tmpfs for config and program guide files to allow hard drive spin-down timer
to kick in and save power.
.B AMD Cool-n-Quiet
or
.B Intel SpeedStep
may also be used to reduce the CPU cycles during capture.
.B atscap
uses very little CPU, even when capturing, so it should keep both methods at
the lowest speed settings.
.IP
.B NOTE:
Mount tmpfs at /dtv/ram, or -p path + "ram/" prior to using this option.
The following files and directories are copied to tmpfs when atscap starts,
and copied back on exit:
.IP
  /etc/hosts.allow  (not copied back to /etc)
  /etc/atscap/*
  /dtv/pg/*         or -p dir/pg/*
  /dtv/pg/img/*     or -p dir/pg/img/*
.IP
If you want to change the running config while using the
.B -E
option, you will need to edit the tmpfs copy of atscap[devnum].conf.
The atscapN.log files are also stored in tmpfs directory and
will be copied and deleted on normal exit.
.IP
.B atscap
does not spin down the drives nor put the CPUs to sleep. You will have to
configure your power management software to handle that part. It will wake up
every 3 hours to save the updated program guides if there are no timers. If
there is a timer, it will attempt to wake up the ATSC device and the HDDs 30s
before capture. See hdparm -S option for IDE HDD spindown settings. SCSI HDD,
USB HDD, FireWire HDD and CPU power reduction may require additional software
outside the scope of this document.
.TP

.TP
.B WARNING: SOME CAPTURES MAY FAIL TO START WITH THIS OPTION!
.TP
.B \-a
Acquisition of Signal check.
.IP
Enabling AOS prevents captures from stations with weak signal strength.
It is
.B NOT
recommended that you use this mode of operation unless you know the driver
for your ATSC device has working signal strength function.

.TP
.B WARNING: SOME CAPTURES MAY BE CORRUPTED WITH THIS OPTION!
.TP
.B \-x
Signal check during capture.
.IP
Enables display of signal strength during capture. This is known to
work well with drivers that have hardware i2c [bt878] for data transfer.
Drivers using software i2c [cx88] have been known to fail when using
this mode of operation. Try it to see if it crashes the driver,
or causes more capture dropouts.

.SH OPTIONS WITH PARAMETERS
.TP
These change defaults to user supplied parameters.

.TP
.B \-i devnum
Selects DVB device number
.B devnum.
.IP
Default is 0 for /dev/dvb/adapter0. 3 is the maximum.

.TP
.B \-c cfgpath
Config file is in
.B cfgpath
directory, or is the file given as
.B cfgpath.
.IP
Default config file is /etc/atscap/atscap[devnum].conf to match -i devnum
.br
See also:
.B -i

.TP
.B \-p outpath
Captures will go to the
.B outpath
directory.
.IP
Default is /dtv.
.br
See also:
.B -s -o

.TP
.B \-o capfile
Output capture to 
.B capfile
overriding default of MMDD-hhmm-CH.ts.
.IP
Mostly used for single capture from cron script.
.br
See also:
.B -s -p

.TP
.B \-s num
Capture arg channel for
.B num
seconds duration; example:
.IP
-s1800 19 gets chan 19 for 30 minutes, ignoring stdin. 19 is not part
of the option, but a single non-option arg. (FIXME)
.br
See also:
.B -o -p -i -q -d

.TP
.B \-z num
Zap cap if QoS drops below
.B num
for one minute. (FIXME)
.IP
The default is 0 for now.

.TP 
.B \-F num
Select frequency table
.B num
from one of the following:
.PP
      8-VSB: (The default if -F not specified)
.IP
.B 0
USA ATSC center frequencies (-28615 Hz)
.PP
    QAM-256: (for testing only, not supported)
.IP
.B 1
USA Cable EAI-542 HRC center frequencies
.br
.B 2
USA Cable EAI-542 IRC center frequencies
.br
.B 3
USA Cable HRC center frequencies
.br
.B 4
USA Cable IRC center frequencies
.br
.B 5
USA Cable Standard center frequencies

.TP
.B \-w addr[:mask:port:threads]
Enable multi-threaded HTTP server subset:
.IP
.B addr
is required, may be dotted IP address or hostname.
.IP
.B mask
defaults to Class C subnet, may be dotted or number of bits notation.
.IP
.B port
is TCP port base range (
.B port + devnum
) to use for the httpd server. It defaults to TCP port 80 + 
.B devnum.
.IP
.B threads
defaults to 5 threads

.TP
.B \-u addr:port
Echo live stream during captures to Multicast UDP IP at
.B addr
and
.B port.
.IP
[u] key will toggle the UDP streaming off or on. Default is on.
.IP
This will probably only work OK with hardware decoders that can render
the required frame rate without delays. Use -n option for hardware deocders.
They need nulls. You also have to set the Virtual Program Number because most
hardware players can't understand multiplexed streams. Captures are saved
for later playback in case there was a problem with the UDP streaming.
.br
See also: -n

.TP
.B \-r file
Read-only replay of captured 
.B file
at >10x speed.
.IP
Mostly used for PSIP debug of atscut -kmgt .ts samples.
Specifying a path overrides default of /dtv/ or -p path.

.SH CONSOLE CONTROLS
These are the console keys you may be able to use while it is running.
.TP
.B Manual Control
.PP
   PGUP/DN scroll keys for navigation
   Arrows  edit-pad scroll keys for navigation
   = [ ] ' non edit-pad scroll keys for navigation

   * = disabled during capture
   $ = disabled during timer

       ctrl-L  clear and refresh display
   *   ctrl-C  abort atscap: exits if no capture in progress
   *   1-9     1-9 keys to select channel and stop/start scan
   *   A-Z     A-Z keys to select channel and stop/start scan
   *   SP      toggle channel lock | scan (spacebar key)
   *   w       toggle strength% | SNR | freq | wavelen
   *   a       toggle automatic EPG for this station (magenta)
   *   q       quit, disabled during capture prevents accidents
   *   TAB     toggle timer/channel list display
   $   NL      [ENTER] start VC capture of MPEG2 on selected VC
   $   BS      [BackSpace Delete] (not ^H) stop capture
       l       load Program Guide for current channel
       o       override in-progress timer to manual, unlocks BS
       p       Event Program Guide (EPG) listings
       v       Virtual Channel display with video + audio select
       g       Master Guide Table (MGT) display, scrollable list
       f       capture log with overall errors per second
       s       statistics display toggle
       z       zap stops capture/deletes files or stops info cap

.B Timer Control (main screen):
.PP
       t       set a timer for channel
       m       move timer to another config file
       r       reschedule/remove a timer or range of timers
       d       delete a timer or range of timers
       e       toggle elaspsed or remaining time for timer
       _       manually reload configuration file
       +       manually save configuration file
       !       delete all timers on list, BE CAREFUL

.B Program Guide Control (screen after [p] key):
.PP
       0-9/A-Z jumps to page of program guide, 0 is first page
       t       add EPG event, or range of events, to timer list
       a       toggle display of aged-out Program Guide events
       h       toggle display of hidden/unavailable/junk events
       m       toggle display of events that match timer names
       n       toggle numeric debug display
       x       clear program guide and stored EIT/ETT payloads
       z       zaps current capture, if any, and exits guide
       p       exits guide

.B Virtual Channel Control (screen after [v] key):
.PP
       c       set the virtual channel number
       a       set the audio stream number
       r       reset to full capture mode
       d       toggle VCT and PMT descriptor details
       m       toggle MPEG/ATSC Virtual Channel info

.SH ENVIRONMENT VARIABLES [NOT IMPLEMENTED YET]
.TP
[TODO: need to write parse_envars()...]
.PP
.B "ATSCAP_FIFO = n       "
allocate n bytes for the FIFO
.br
.B "ATSCAP_UDP  = a:p     "
same as parameters for UDP *cast
.br
.B "ATSCAP_TCP  = a:m:p:t "
same as parameters for httpd bind

.SH WEB SERVER CONFIGURATION
If you're not using -w option, you can skip this section. However, a lot
of work has gone into making the web server easy to use, so you really
should consider using the -w mode unless you actually like the console.
The user is expected to employ safe internet practices by using firewalls.

.IP
.B atscap -i0 -w 1.2.3.1:24:1080:5
.PP
Starts the http server for a 253 IP subnet at 1.2.3.1, on port 1080
with a maximum of 5 threads to be used for http, on dvb0.dvr0.
This is assuming you have a TCP/IP interface at 1.2.3.1.
.IP
.B atscap -i1 -w dtv:0:380:5
.PP
Starts the http server at port 380, without a netmask with 5 threads.
.IP
.B atscap -i1 -w dtv:0
.PP
Starts the http server at default port 1381 (default 1380 + devnum),
without a netmask and with the default of 5 threads.

.IP
The atscap TCP wrapper emulation default denies all traffic external to the
interface. Use /etc/hosts and/or /etc/hosts.allow (or tmpfs copy if using -E)
to grant access to the atscap web interface:
.TP
/etc/hosts:
.IP
1.2.3.1 dtv
.br
1.2.3.2 player
.TP
/etc/hosts.allow:
.IP
atscap: player
.PP
NOTE: NAT access isn't well tested. Because of this and the fact that the
web server code might have security flaws, it is NOT recommended allowing
public access to the HTTP user interface. Use netfilter + iptables if you
need to punch a hole to serve broadcast EPGs to a buddy on cable.
.PP
If you use a hostname to access it behind NAT, you will need to update
/etc/hosts with the hostname you will use, with different IP addresses
on the server and the client machines.
.PP

.SH WEB BROWSER CONFIGURATION
If you're not using -w option, you can skip these sub-sections.

.PP
.B PLAYER SCRIPT CONFIGURATION
.IP
You need to register the mpeg:// protocol into mozilla.
Any URI with mpeg:// calls mpeg.sh.
.PP
In the mozilla url entry box, enter this:
.IP
about:config
.PP
Right mouse to bring up menu then:
.IP
New -> String:
.br
network.protocol-handler.app.mpeg
.br
/usr/local/bin/mpeg.sh
(or where you put mpeg.sh)
.PP
Right mouse to bring up menu then:
.IP
New -> Boolean:
.br
network.protocol-handler.external.mpeg
.br
true
.PP
Right mouse to bring up menu then:
.IP
New -> Boolean:
.br
network.protocol-handler.warn-external.mpeg
.br
false (true warns you before playing)

.PP
.B EDITOR SCRIPT CONFIGURATION
.IP
You also need registers the xtc:// protocol into mozilla.
Any URI with xtc:// calls xtc.sh.
.PP
In the mozilla url entry box, enter this:
.IP
about:config
.PP
Right mouse to bring up menu then:
.IP
New -> String:
.br
network.protocol-handler.app.xtc
.br
/usr/local/bin/xtc.sh
(or where you put xtc.sh)
.PP
Right mouse to bring up menu then:
.IP
New -> Boolean:
.br
network.protocol-handler.external.xtc
.br
true
.PP
Right mouse to bring up menu then:
.IP
New -> Boolean:
.br
network.protocol-handler.warn-external.xtc
.br
false (true warns you before editing)

.SH UDP SERVER CONFIGURATION [WARNING: NOT WELL TESTED]
Use this for relaying live capture to other local clients, even WiFi.
Assume for these examples the server local IP address is 1.2.3.1,
with a hostname of dtv.
.PP
.B MULTICAST
.PP
This can be received by multiple devices:
.IP
.B -u 224.1.2.3:1234
.PP
Multicast will be chosen if you use a Multicast address.
Compile a kernel with UDP Multicast enabled, tunnelling and routing are not
needed for local relay, for every machine that will receive the stream.
.PP
Software decoders can play it back like this:
.IP
.B xine -p udp://224.1.2.3:1234
.PP
.B UNICAST (FIXME/TODO)
.IP
.B PLEASE BE CAREFUL WHERE YOU POINT THAT UDP CANNON!
.PP
This can be received by only one client at 1.2.3.3:
.IP
.B -u 1.2.3.3:1234
.PP
Unicast will be chosen if you don't use a Multicast address.
Software decoders can play it back like this:
.IP
.B xine -p udp://1.2.3.1:1234
.PP
.B HARDWARE DECODER ISSUES
.PP
The UDP Multi/Unicast option is primarily for hardware decoder support.
Hardware decoders will also need -n option to pad the stream with nulls
to keep the bitrate at what the decoder expects.
.PP
The hardware decoders that support UDP may also support Multicast.
If so, use it. If not, you will be limited to Unicast mode.
.PP
.B SOFTWARE DECODER ISSUES
.PP
UDP testing doesn't play very smoothly here. It's not any better than
telling xine to read the card live. Using TCP for software playback of
capture files works much better, via mounted filesystem or
.B -w
HTTP server:

.B RTP/RTSP IS NOT IMPLEMENTED
.PP
Because atscap is primarily designed for a single user, multi-stream
VOD using RTP/RTSP/RSVP or STCP is not currently implemented. If
you want this feature, write it and post the patch.

.B XINE PLAYBACK EXAMPLE FOR HTTP
.IP
.B xine -p http://dtv:80/CaptureFile-1220-2300.3.ts
.PP
It has been reported that mplayer navigates via http:// better than
xine because mplayer supports the HTTP Range: directive.
Both work fine when playback is from a mounted filesystem.
Using a VLC server is outside the scope of this document.

.SH QUICK START EXAMPLE
Check DVB device for ATSC stations and create configuration file:
.IP
.B atscap -i0 -S
(single card users or first card)
.PP
Multi-card users may save time by copying the first config file, or
if your antennas have widely varying signal qualities, do the rest:
.IP
.B atscap -i1 -S
(two card users)
.br
.B atscap -i2 -S
(three card users)
.br
.B atscap -i3 -S
(four card users)
.PP

.SH SIGNAL OPTIONS
.B atscap
accepts the following signals via kill or killall:
    -2  SIGINT is same as control-c, but does not work during capture
    -15 SIGTERM save the state and if needed stops any current capture
    -9  SIGKILL kills it if other signals fail to do same
    
.SH HISTORY
.B atscap
was written because no fast forward, no rewind and no pause
is not Advanced Television!

.SH BUGS
All kinds! Good luck finding them! Please send bug reports and patches.

.SH SEE ALSO
.PP
atscap_conf(5), atscut(1), xtscut(1), screen(1), hosts_access(5), mount(8)
.PP
The ATSC specifications may be found at the following location:
.IP
.B http://www.atsc.org/

.SH AUTHOR
.PP
The author of this manual page is
.B <inkling@users.sourceforge.net>

.SH COPYRIGHT
.PP
This manual page is part of the atscap-1.1 distribution software.
.PP
atscap is Copyright (C) 2004-2007 by
.B <inkling@users.sourceforge.net>

.SH LICENSE
.PP
Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU General Public License, Version 2.
.PP
A copy of the GPLv2 with the file name COPYING or LICENSE should have been
included in this distribution. If it was not included, please contact me,
.B <inkling@users.sourceforge.net>,
or write to:
.IP
 The Free Software Foundation, Inc.
 51 Franklin Street, Fifth Floor
 Boston, MA 02110-1301, USA
